Index: LMDZ6/trunk/libf/phylmd/lmdz_lscp_ini.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/lmdz_lscp_ini.F90	(revision 4818)
+++ LMDZ6/trunk/libf/phylmd/lmdz_lscp_ini.F90	(revision 4830)
@@ -112,12 +112,12 @@
   !$OMP THREADPRIVATE(coef_eva)
 
-  REAL, SAVE, PROTECTED :: coef_eva_i                       ! tuning coefficient ice precip sublimation
-  !$OMP THREADPRIVATE(coef_eva_i)
+  REAL, SAVE, PROTECTED :: coef_sub                        ! tuning coefficient ice precip sublimation
+  !$OMP THREADPRIVATE(coef_sub)
 
   REAL, SAVE, PROTECTED :: expo_eva=0.5                     ! tuning coefficient liquid precip evaporation
   !$OMP THREADPRIVATE(expo_eva)
 
-  REAL, SAVE, PROTECTED :: expo_eva_i                       ! tuning coefficient ice precip sublimation
-  !$OMP THREADPRIVATE(expo_eva_i)
+  REAL, SAVE, PROTECTED :: expo_sub                       ! tuning coefficient ice precip sublimation
+  !$OMP THREADPRIVATE(expo_sub)
 
   REAL, SAVE, PROTECTED :: cice_velo=1.645                  ! factor in the ice fall velocity formulation
@@ -137,4 +137,10 @@
   !$OMP THREADPRIVATE(ok_poprecip)
 
+  REAL, SAVE, PROTECTED :: cld_lc_lsc_snow               ! snow autoconversion coefficient, stratiform rain
+  !$OMP THREADPRIVATE(cld_lc_lsc_snow)
+
+  REAL, SAVE, PROTECTED :: cld_lc_con_snow                ! snow autoconversion coefficient, convective rain
+  !$OMP THREADPRIVATE(cld_lc_con_snow)
+
   REAL, SAVE, PROTECTED :: rain_int_min=0.001               ! Minimum local rain intensity [mm/s] before the decrease in associated precipitation fraction
   !$OMP THREADPRIVATE(rain_int_min)
@@ -155,5 +161,5 @@
   !$OMP THREADPRIVATE(rho_rain)
 
-  REAL, SAVE, PROTECTED :: rho_snow=500.                   ! A COMMENTER TODO [kg/m3]
+  REAL, SAVE, PROTECTED :: rho_snow                        ! A COMMENTER TODO [kg/m3]
   !$OMP THREADPRIVATE(rho_snow)
 
@@ -164,8 +170,8 @@
   !$OMP THREADPRIVATE(r_snow)
 
-  REAL, SAVE, PROTECTED :: tau_auto_snow_min=1800.          ! A COMMENTER TODO [s]
+  REAL, SAVE, PROTECTED :: tau_auto_snow_min=100.          ! A COMMENTER TODO [s]
   !$OMP THREADPRIVATE(tau_auto_snow_min)
 
-  REAL, SAVE, PROTECTED :: tau_auto_snow_max=7200.          ! A COMMENTER TODO [s]
+  REAL, SAVE, PROTECTED :: tau_auto_snow_max=1000.          ! A COMMENTER TODO [s]
   !$OMP THREADPRIVATE(tau_auto_snow_max)
 
@@ -182,6 +188,27 @@
   !$OMP THREADPRIVATE(alpha_freez)
 
-  REAL, SAVE, PROTECTED :: gamma_freez=0.1               ! A COMMENTER TODO [m-3.s-1]
+  REAL, SAVE, PROTECTED :: beta_freez=0.1                 ! A COMMENTER TODO [m-3.s-1]
+  !$OMP THREADPRIVATE(beta_freez)
+
+  REAL, SAVE, PROTECTED :: gamma_freez=1.                 ! A COMMENTER TODO [-]
   !$OMP THREADPRIVATE(gamma_freez)
+
+  REAL, SAVE, PROTECTED :: rain_fallspeed=4.              ! A COMMENTER TODO [m/s]
+  !$OMP THREADPRIVATE(rain_fallspeed)
+
+  REAL, SAVE, PROTECTED :: rain_fallspeed_clr              ! A COMMENTER TODO [m/s]
+  !$OMP THREADPRIVATE(rain_fallspeed_clr)
+
+  REAL, SAVE, PROTECTED :: rain_fallspeed_cld             ! A COMMENTER TODO [m/s]
+  !$OMP THREADPRIVATE(rain_fallspeed_cld)
+
+  REAL, SAVE, PROTECTED :: snow_fallspeed=1.             ! A COMMENTER TODO [m/s]
+  !$OMP THREADPRIVATE(snow_fallspeed)
+
+  REAL, SAVE, PROTECTED :: snow_fallspeed_clr             ! A COMMENTER TODO [m/s]
+  !$OMP THREADPRIVATE(snow_fallspeed_clr)
+
+  REAL, SAVE, PROTECTED :: snow_fallspeed_cld             ! A COMMENTER TODO [m/s]
+  !$OMP THREADPRIVATE(snow_fallspeed_cld)
   !--End of the parameters for poprecip
 
@@ -246,4 +273,8 @@
     CALL getin_p('cld_lc_lsc',cld_lc_lsc)
     CALL getin_p('cld_lc_con',cld_lc_con)
+    cld_lc_lsc_snow=cld_lc_lsc
+    cld_lc_con_snow=cld_lc_con
+    CALL getin_p('cld_lc_lsc_snow',cld_lc_lsc_snow)
+    CALL getin_p('cld_lc_con_snow',cld_lc_con_snow)
     CALL getin_p('cld_tau_lsc',cld_tau_lsc)
     CALL getin_p('cld_tau_con',cld_tau_con)
@@ -253,9 +284,10 @@
     CALL getin_p('ffallv_lsc',ffallv_con)
     CALL getin_p('coef_eva',coef_eva)
-    coef_eva_i=coef_eva
-    CALL getin_p('coef_eva_i',coef_eva_i)
+    coef_sub=coef_eva
+    CALL getin_p('coef_eva_i',coef_sub)
+    CALL getin_p('coef_sub',coef_sub)
     CALL getin_p('expo_eva',expo_eva)
-    expo_eva_i=expo_eva
-    CALL getin_p('expo_eva_i',expo_eva_i)
+    expo_sub=expo_eva
+    CALL getin_p('expo_sub',expo_sub)
     CALL getin_p('iflag_autoconversion',iflag_autoconversion)
     CALL getin_p('dist_liq',dist_liq)
@@ -267,4 +299,16 @@
     CALL getin_p('gamma_col',gamma_col)
     CALL getin_p('gamma_rim',gamma_rim)
+    CALL getin_p('gamma_freez',gamma_freez)
+    CALL getin_p('r_snow',r_snow)
+    CALL getin_p('rain_fallspeed',rain_fallspeed)
+    rain_fallspeed_clr=rain_fallspeed
+    rain_fallspeed_cld=rain_fallspeed
+    CALL getin_p('rain_fallspeed_clr',rain_fallspeed_clr)
+    CALL getin_p('rain_fallspeed_cld',rain_fallspeed_cld)
+    CALL getin_p('snow_fallspeed',snow_fallspeed)
+    snow_fallspeed_clr=snow_fallspeed
+    snow_fallspeed_cld=snow_fallspeed
+    CALL getin_p('snow_fallspeed_clr',snow_fallspeed_clr)
+    CALL getin_p('snow_fallspeed_cld',snow_fallspeed_cld)
 
 
@@ -289,4 +333,6 @@
     WRITE(lunout,*) 'lscp_ini, cld_lc_lsc', cld_lc_lsc
     WRITE(lunout,*) 'lscp_ini, cld_lc_con', cld_lc_con
+    WRITE(lunout,*) 'lscp_ini, cld_lc_lsc_snow', cld_lc_lsc_snow
+    WRITE(lunout,*) 'lscp_ini, cld_lc_con_snow', cld_lc_con_snow
     WRITE(lunout,*) 'lscp_ini, cld_tau_lsc', cld_tau_lsc
     WRITE(lunout,*) 'lscp_ini, cld_tau_con', cld_tau_con
@@ -296,7 +342,7 @@
     WRITE(lunout,*) 'lscp_ini, ffallv_con', ffallv_con
     WRITE(lunout,*) 'lscp_ini, coef_eva', coef_eva
-    WRITE(lunout,*) 'lscp_ini, coef_eva_i', coef_eva_i
+    WRITE(lunout,*) 'lscp_ini, coef_sub', coef_sub
     WRITE(lunout,*) 'lscp_ini, expo_eva', expo_eva
-    WRITE(lunout,*) 'lscp_ini, expo_eva_i', expo_eva_i
+    WRITE(lunout,*) 'lscp_ini, expo_sub', expo_sub
     WRITE(lunout,*) 'lscp_ini, iflag_autoconversion', iflag_autoconversion
     WRITE(lunout,*) 'lscp_ini, dist_liq', dist_liq
@@ -309,4 +355,10 @@
     WRITE(lunout,*) 'lscp_ini, gamma_col:', gamma_col
     WRITE(lunout,*) 'lscp_ini, gamma_rim:', gamma_rim
+    WRITE(lunout,*) 'lscp_ini, gamma_freez:', gamma_freez
+    WRITE(lunout,*) 'lscp_ini, r_snow:', r_snow
+    WRITE(lunout,*) 'lscp_ini, rain_fallspeed_clr:', rain_fallspeed_clr
+    WRITE(lunout,*) 'lscp_ini, rain_fallspeed_cld:', rain_fallspeed_cld
+    WRITE(lunout,*) 'lscp_ini, snow_fallspeed_clr:', snow_fallspeed_clr
+    WRITE(lunout,*) 'lscp_ini, snow_fallspeed_cld:', snow_fallspeed_cld
 
 
@@ -341,4 +393,8 @@
     ENDIF
 
+    !--Initialisations of constants depending on other constants
+    !--rho_snow formula from r_snow (Brandes et al. 2007 - JAMC)
+    rho_snow = 1.e3 * 0.178 * (r_snow * 2. * 1000.)**(-0.922)
+
 
     !AA Temporary initialisation