Index: /LMDZ6/trunk/libf/phylmd/lmdz_thermcell_env.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/lmdz_thermcell_env.F90	(revision 4843)
+++ /LMDZ6/trunk/libf/phylmd/lmdz_thermcell_env.F90	(revision 4844)
@@ -82,4 +82,5 @@
    do ig=1,ngrid
       lcong(ig)=1
+      lintercong(ig)=0.
    enddo
    do ig=1,ngrid
Index: /LMDZ6/trunk/libf/phylmdiso/phys_local_var_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmdiso/phys_local_var_mod.F90	(revision 4843)
+++ /LMDZ6/trunk/libf/phylmdiso/phys_local_var_mod.F90	(revision 4844)
@@ -451,6 +451,6 @@
       REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: alp_bl_fluct_m,alp_bl_fluct_tke
 !$OMP THREADPRIVATE(alp_bl_fluct_m,alp_bl_fluct_tke)
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: alp_bl_stat, n2, s2
-!$OMP THREADPRIVATE(alp_bl_stat, n2, s2)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: alp_bl_stat, n2, s2, strig, zcong, zlcl_th
+!$OMP THREADPRIVATE(alp_bl_stat, n2, s2, strig, zcong, zlcl_th)
       REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: proba_notrig, random_notrig
 !$OMP THREADPRIVATE(proba_notrig, random_notrig)
@@ -1008,5 +1008,5 @@
       ALLOCATE(alp_bl_fluct_m(klon), alp_bl_fluct_tke(klon))
       alp_bl_fluct_m(:)=0 ; alp_bl_fluct_tke(:)= 0.
-      ALLOCATE(alp_bl_stat(klon), n2(klon), s2(klon))
+      ALLOCATE(alp_bl_stat(klon), n2(klon), s2(klon), strig(klon), zcong(klon), zlcl_th(klon))
       alp_bl_stat(:)=0
       ALLOCATE(proba_notrig(klon), random_notrig(klon))
@@ -1385,5 +1385,5 @@
       DEALLOCATE(alp_bl_conv,alp_bl_det)
       DEALLOCATE(alp_bl_fluct_m,alp_bl_fluct_tke)
-      DEALLOCATE(alp_bl_stat, n2, s2)
+      DEALLOCATE(alp_bl_stat, n2, s2, strig, zcong, zlcl_th)
       DEALLOCATE(proba_notrig, random_notrig)
 !FC
Index: /LMDZ6/trunk/libf/phylmdiso/phys_output_ctrlout_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmdiso/phys_output_ctrlout_mod.F90	(revision 4843)
+++ /LMDZ6/trunk/libf/phylmdiso/phys_output_ctrlout_mod.F90	(revision 4844)
@@ -857,5 +857,10 @@
   TYPE(ctrl_out), SAVE :: o_s2 = ctrl_out((/ 1, 6, 6, 6, 10, 10, 11, 11, 11, 11/), &
     's2', 'Surface moyenne des panaches de type 2', 'm2', (/ ('', i=1, 10) /))
-              
+  TYPE(ctrl_out), SAVE :: o_strig = ctrl_out((/ 1, 6, 6, 6, 10, 10, 11, 11, 11, 11/), &
+    'strig', 'Surface moyenne pour atteindre niveau de congelation', 'm2', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_zcong = ctrl_out((/ 1, 6, 6, 6, 10, 10, 11, 11, 11, 11/), &
+    'zcong', 'niveau de congelation', 'm', (/ ('', i=1, 10) /))  
+  TYPE(ctrl_out), SAVE :: o_zlcl_th = ctrl_out((/ 1, 6, 6, 6, 10, 10, 11, 11, 11, 11/), &
+    'zlcl_th', 'niveau de condensation', 'm', (/ ('', i=1, 10) /))                   
 !-------Déclenchement stochastique
   TYPE(ctrl_out), SAVE :: o_proba_notrig = ctrl_out((/ 1, 6, 6, 6, 10, 10, 11, 11, 11, 11/), &
Index: /LMDZ6/trunk/libf/phylmdiso/physiq_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmdiso/physiq_mod.F90	(revision 4843)
+++ /LMDZ6/trunk/libf/phylmdiso/physiq_mod.F90	(revision 4844)
@@ -319,5 +319,5 @@
        alp_bl_conv,alp_bl_det,  &
        alp_bl_fluct_m,alp_bl_fluct_tke,  &
-       alp_bl_stat, n2, s2,  &
+       alp_bl_stat, n2, s2,  strig, zcong, zlcl_th, &
        proba_notrig, random_notrig,  &
 !!       cv_gen,  &  !moved to phys_state_var_mod
@@ -796,5 +796,5 @@
     !--------Stochastic Boundary Layer Triggering: ALE_BL--------
     !---Propri\'et\'es du thermiques au LCL 
-    real zlcl_th(klon)          ! Altitude du LCL calcul\'e
+!    real zlcl_th(klon)          ! Altitude du LCL calcul\'e
     ! continument (pcon dans
     ! thermcell_main.F90)
@@ -4557,5 +4557,5 @@
                ,pbl_tke_input,pctsrf,omega,cell_area &
                ,zlcl_th,fraca0,w0,w_conv,therm_tke_max0,env_tke_max0 &
-               ,n2,s2,ale_bl_stat &
+               ,n2,s2,strig,zcong,ale_bl_stat &
                ,therm_tke_max,env_tke_max &
                ,alp_bl_det,alp_bl_fluct_m,alp_bl_fluct_tke &
@@ -4626,5 +4626,5 @@
 !
           CALL alpale_th( phys_tstep, lmax_th, t_seri, cell_area,  &
-                          cin, s2, n2,  &
+                          cin, s2, n2, strig, &
                           ale_bl_trig, ale_bl_stat, ale_bl,  &
                           alp_bl, alp_bl_stat, &