Index: /LMDZ6/trunk/DefLists/field_def_lmdz.xml
===================================================================
--- /LMDZ6/trunk/DefLists/field_def_lmdz.xml	(revision 4845)
+++ /LMDZ6/trunk/DefLists/field_def_lmdz.xml	(revision 4846)
@@ -326,4 +326,7 @@
         <field id="n2"    long_name="Nombre de panaches de type 2"    unit="-" />
         <field id="s2"    long_name="Surface moyenne des panaches de type 2"    unit="m2" />
+	<field id="strig" long_name="Surface moyenne pour atteindre niveau de congelation"  unit="m2" />
+        <field id="zcong" long_name="niveau de congelation" unit="m" />
+        <field id="zlcl_th" long_name="niveau de condensation" unit="m" />
         <field id="proba_notrig"    long_name="Probabilite de non-declenchement"    unit="-" />
         <field id="random_notrig"    long_name="Tirage aleatoire de non-declenchement"    unit="-" />
Index: /LMDZ6/trunk/DefLists/file_def_histLES_lmdz.xml
===================================================================
--- /LMDZ6/trunk/DefLists/file_def_histLES_lmdz.xml	(revision 4845)
+++ /LMDZ6/trunk/DefLists/file_def_histLES_lmdz.xml	(revision 4846)
@@ -232,4 +232,7 @@
                 <field field_ref="n2" level="10" />
                 <field field_ref="s2" level="10" />
+                <field field_ref="strig" level="10" />
+                <field field_ref="zcong" level="10" />
+                <field field_ref="zlcl_th" level="10" />
                 <field field_ref="proba_notrig" level="10" />
                 <field field_ref="random_notrig" level="10" />
Index: /LMDZ6/trunk/DefLists/file_def_histday_lmdz.xml
===================================================================
--- /LMDZ6/trunk/DefLists/file_def_histday_lmdz.xml	(revision 4845)
+++ /LMDZ6/trunk/DefLists/file_def_histday_lmdz.xml	(revision 4846)
@@ -233,4 +233,7 @@
                 <field field_ref="n2" level="1" />
                 <field field_ref="s2" level="1" />
+                <field field_ref="strig" level="1" />
+                <field field_ref="zcong" level="1" />
+                <field field_ref="zlcl_th" level="1" />
                 <field field_ref="proba_notrig" level="1" />
                 <field field_ref="random_notrig" level="1" />
Index: /LMDZ6/trunk/DefLists/file_def_histhfCOSPoff_lmdz.xml
===================================================================
--- /LMDZ6/trunk/DefLists/file_def_histhfCOSPoff_lmdz.xml	(revision 4845)
+++ /LMDZ6/trunk/DefLists/file_def_histhfCOSPoff_lmdz.xml	(revision 4846)
@@ -250,4 +250,7 @@
                 <field field_ref="n2" level="6" />
                 <field field_ref="s2" level="6" />
+                <field field_ref="strig" level="6" />
+                <field field_ref="zcong" level="6" />
+                <field field_ref="zlcl_th" level="6" />
                 <field field_ref="proba_notrig" level="6" />
                 <field field_ref="random_notrig" level="6" />
Index: /LMDZ6/trunk/DefLists/file_def_histhfECRADoff_lmdz.xml
===================================================================
--- /LMDZ6/trunk/DefLists/file_def_histhfECRADoff_lmdz.xml	(revision 4845)
+++ /LMDZ6/trunk/DefLists/file_def_histhfECRADoff_lmdz.xml	(revision 4846)
@@ -250,4 +250,7 @@
                 <field field_ref="n2" level="6" />
                 <field field_ref="s2" level="6" />
+                <field field_ref="strig" level="6" />
+                <field field_ref="zcong" level="6" />
+                <field field_ref="zlcl_th" level="6" />
                 <field field_ref="proba_notrig" level="6" />
                 <field field_ref="random_notrig" level="6" />
Index: /LMDZ6/trunk/DefLists/file_def_histhf_lmdz.xml
===================================================================
--- /LMDZ6/trunk/DefLists/file_def_histhf_lmdz.xml	(revision 4845)
+++ /LMDZ6/trunk/DefLists/file_def_histhf_lmdz.xml	(revision 4846)
@@ -237,4 +237,7 @@
                 <field field_ref="n2" level="6" />
                 <field field_ref="s2" level="6" />
+                <field field_ref="strig" level="6" />
+                <field field_ref="zcong" level="6" />
+                <field field_ref="zlcl_th" level="6" />
                 <field field_ref="proba_notrig" level="6" />
                 <field field_ref="random_notrig" level="6" />
Index: /LMDZ6/trunk/DefLists/file_def_histins_lmdz.xml
===================================================================
--- /LMDZ6/trunk/DefLists/file_def_histins_lmdz.xml	(revision 4845)
+++ /LMDZ6/trunk/DefLists/file_def_histins_lmdz.xml	(revision 4846)
@@ -233,4 +233,7 @@
                 <field field_ref="n2" level="1" />
                 <field field_ref="s2" level="1" />
+                <field field_ref="strig" level="1" />
+                <field field_ref="zcong" level="1" />
+                <field field_ref="zlcl_th" level="1" />
                 <field field_ref="proba_notrig" level="1" />
                 <field field_ref="random_notrig" level="1" />
Index: /LMDZ6/trunk/DefLists/file_def_histmth_lmdz.xml
===================================================================
--- /LMDZ6/trunk/DefLists/file_def_histmth_lmdz.xml	(revision 4845)
+++ /LMDZ6/trunk/DefLists/file_def_histmth_lmdz.xml	(revision 4846)
@@ -269,4 +269,7 @@
                 <field field_ref="n2" level="1" />
                 <field field_ref="s2" level="1" />
+                <field field_ref="strig" level="1" />
+                <field field_ref="zcong" level="1" />
+                <field field_ref="zlcl_th" level="1" />
                 <field field_ref="proba_notrig" level="1" />
                 <field field_ref="random_notrig" level="1" />
Index: /LMDZ6/trunk/DefLists/file_def_histstn_lmdz.xml
===================================================================
--- /LMDZ6/trunk/DefLists/file_def_histstn_lmdz.xml	(revision 4845)
+++ /LMDZ6/trunk/DefLists/file_def_histstn_lmdz.xml	(revision 4846)
@@ -231,4 +231,7 @@
                 <field field_ref="n2" level="10" />
                 <field field_ref="s2" level="10" />
+                <field field_ref="strig" level="10" />
+                <field field_ref="zcong" level="10" />
+                <field field_ref="zlcl_th" level="10" />
                 <field field_ref="proba_notrig" level="10" />
                 <field field_ref="random_notrig" level="10" />